//: C07:Stlshape2.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Stlshape.cpp s funkcí purge().
#include <iostream>
#include <vector>
#include "../purge.h"
using namespace std;

class Tvar {
public:
  virtual void vykresli() = 0;
  virtual ~Tvar() {};
};

class Kruh : public Tvar {
public:
  void vykresli() { cout << "Kruh::vykresli" << endl; }
  ~Kruh() { cout << "~Kruh" << endl; }
};

class Trojuhelnik : public Tvar {
public:
  void vykresli() { cout << "Trojuhelnik::vykresli" << endl; }
  ~Trojuhelnik() { cout << "~Trojuhelnik" << endl; }
};

class Ctverec : public Tvar {
public:
  void vykresli() { cout << "Ctverec::vykresli" << endl; }
  ~Ctverec() { cout << "~Ctverec" << endl; }
};

int main() {
  typedef std::vector<Tvar*> Kontejner;
  typedef Kontejner::iterator Iter;
  Kontejner tvary;
  tvary.push_back(new Kruh);
  tvary.push_back(new Ctverec);
  tvary.push_back(new Trojuhelnik);
  for(Iter i = tvary.begin(); i != tvary.end(); i++)
    (*i)->vykresli();
  purge(tvary);
} ///:~
